"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GmsConsentStatus(ProtocolElement):
    """
    Consent Status for GMS
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "carrierStatusConsent",
        "healthRelatedFindingConsent",
        "pharmacogenomicsFindingConsent",
        "primaryFindingConsent",
        "programmeConsent",
        "researchConsent",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import participant as participant_1_3_0

        return {
            "carrierStatusConsent": participant_1_3_0.GenericConsent,
            "healthRelatedFindingConsent": participant_1_3_0.GenericConsent,
            "pharmacogenomicsFindingConsent": participant_1_3_0.GenericConsent,
            "primaryFindingConsent": participant_1_3_0.GenericConsent,
            "programmeConsent": participant_1_3_0.GenericConsent,
            "researchConsent": participant_1_3_0.GenericConsent,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import participant as participant_1_3_0

        return {
            "org.gel.models.participant.avro.GenericConsent": participant_1_3_0.GenericConsent,
            "org.gel.models.participant.avro.GenericConsent": participant_1_3_0.GenericConsent,
            "org.gel.models.participant.avro.GenericConsent": participant_1_3_0.GenericConsent,
            "org.gel.models.participant.avro.GenericConsent": participant_1_3_0.GenericConsent,
            "org.gel.models.participant.avro.GenericConsent": participant_1_3_0.GenericConsent,
            "org.gel.models.participant.avro.GenericConsent": participant_1_3_0.GenericConsent,
            "org.gel.models.participant.avro.GmsConsentStatus": participant_1_3_0.GmsConsentStatus,
        }

    __slots__ = [
        "carrierStatusConsent",
        "healthRelatedFindingConsent",
        "pharmacogenomicsFindingConsent",
        "primaryFindingConsent",
        "programmeConsent",
        "researchConsent",
    ]

    def __init__(
        self,
        carrierStatusConsent,
        healthRelatedFindingConsent,
        pharmacogenomicsFindingConsent,
        primaryFindingConsent,
        programmeConsent,
        researchConsent,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_3_0.GmsConsentStatus model.

        :param carrierStatusConsent:
            Consent for carrier status check?
        :type carrierStatusConsent: GenericConsent
        :param healthRelatedFindingConsent:
            Consent for secondary health related findings?
        :type healthRelatedFindingConsent: GenericConsent
        :param pharmacogenomicsFindingConsent:
            Consent for pharmacogenomics consent as secondary findings?
        :type pharmacogenomicsFindingConsent: GenericConsent
        :param primaryFindingConsent:
            Consent for feedback of primary findings?         RD: Primary Findings
            Cancer: PrimaryFindings is somatic + pertinent germline
            findings
        :type primaryFindingConsent: GenericConsent
        :param programmeConsent:
            Is this individual consented to the programme? It could simply be a
            family member that is not consented         but for whom
            affection status is known
        :type programmeConsent: GenericConsent
        :param researchConsent:
            Research Consent
        :type researchConsent: GenericConsent
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
